// Code generated by smithy-go-codegen DO NOT EDIT.

package types

import (
	"time"
)

// Stores information about a field passed inside a request that resulted in an
// exception.
type ValidationExceptionField struct {

	// Message describing why the field failed validation.
	//
	// This member is required.
	Message *string

	// The field name.
	//
	// This member is required.
	Name *string
}

// Represents the properties of a workspace.
type WorkspaceDescription struct {

	// The Amazon Resource Name (ARN) of this workspace.
	//
	// This member is required.
	Arn *string

	// The time when the workspace was created.
	//
	// This member is required.
	CreatedAt *time.Time

	// The status of this workspace.
	//
	// This member is required.
	Status *WorkspaceStatus

	// Unique string identifying this workspace.
	//
	// This member is required.
	WorkspaceId *string

	// Alias of this workspace.
	Alias *string

	// Prometheus endpoint URI.
	PrometheusEndpoint *string
}

// Represents the status of a workspace.
type WorkspaceStatus struct {

	// Status code of this workspace.
	//
	// This member is required.
	StatusCode WorkspaceStatusCode
}

// Represents a summary of the properties of a workspace.
type WorkspaceSummary struct {

	// The AmazonResourceName of this workspace.
	//
	// This member is required.
	Arn *string

	// The time when the workspace was created.
	//
	// This member is required.
	CreatedAt *time.Time

	// The status of this workspace.
	//
	// This member is required.
	Status *WorkspaceStatus

	// Unique string identifying this workspace.
	//
	// This member is required.
	WorkspaceId *string

	// Alias of this workspace.
	Alias *string
}
