// Code generated by smithy-go-codegen DO NOT EDIT.

package types

import (
	"time"
)

// Internal only API.
type Dimension struct {

	// Internal only API.
	//
	// This member is required.
	Name *string

	// Internal only API.
	//
	// This member is required.
	Value *string
}

// An Amazon MWAA environment.
type Environment struct {

	// The Airflow Configuration Options of the Amazon MWAA Environment.
	AirflowConfigurationOptions map[string]string

	// The AirflowV ersion of the Amazon MWAA Environment.
	AirflowVersion *string

	// The ARN of the Amazon MWAA Environment.
	Arn *string

	// The Created At date of the Amazon MWAA Environment.
	CreatedAt *time.Time

	// The Dags S3 Path of the Amazon MWAA Environment.
	DagS3Path *string

	// The Environment Class (size) of the Amazon MWAA Environment.
	EnvironmentClass *string

	// The Execution Role ARN of the Amazon MWAA Environment.
	ExecutionRoleArn *string

	// The Kms Key of the Amazon MWAA Environment.
	KmsKey *string

	// Last update information for the environment.
	LastUpdate *LastUpdate

	// The Logging Configuration of the Amazon MWAA Environment.
	LoggingConfiguration *LoggingConfiguration

	// The maximum number of workers to run in your Amazon MWAA Environment.
	MaxWorkers *int32

	// The minimum number of workers to run in your Amazon MWAA Environment.
	MinWorkers *int32

	// The name of the Amazon MWAA Environment.
	Name *string

	// Provide the security group and subnet IDs for the workers and scheduler.
	NetworkConfiguration *NetworkConfiguration

	// The Plugins.zip S3 Object Version of the Amazon MWAA Environment.
	PluginsS3ObjectVersion *string

	// The Plugins.zip S3 Path of the Amazon MWAA Environment.
	PluginsS3Path *string

	// The Requirements.txt file S3 Object Version of the Amazon MWAA Environment.
	RequirementsS3ObjectVersion *string

	// The Requirement.txt S3 Path of the Amazon MWAA Environment.
	RequirementsS3Path *string

	// The Service Role ARN of the Amazon MWAA Environment.
	ServiceRoleArn *string

	// The Source S3 Bucket ARN of the Amazon MWAA Environment.
	SourceBucketArn *string

	// The status of the Amazon MWAA Environment.
	Status EnvironmentStatus

	// The Tags of the Amazon MWAA Environment.
	Tags map[string]string

	// The Webserver Access Mode of the Amazon MWAA Environment (public or private
	// only).
	WebserverAccessMode WebserverAccessMode

	// The Webserver URL of the Amazon MWAA Environment.
	WebserverUrl *string

	// The Weekly Maintenance Window Start of the Amazon MWAA Environment.
	WeeklyMaintenanceWindowStart *string
}

// Last update information for the environment.
type LastUpdate struct {

	// Time that last update occurred.
	CreatedAt *time.Time

	// Error string of last update, if applicable.
	Error *UpdateError

	// Status of last update of SUCCESS, FAILED, CREATING, DELETING.
	Status UpdateStatus
}

// The Logging Configuration of your Amazon MWAA environment.
type LoggingConfiguration struct {

	// A JSON blob that provides configuration to use for logging with respect to the
	// various Apache Airflow services: DagProcessingLogs, SchedulerLogs, TaskLogs,
	// WebserverLogs, and WorkerLogs.
	DagProcessingLogs *ModuleLoggingConfiguration

	// A JSON blob that provides configuration to use for logging with respect to the
	// various Apache Airflow services: DagProcessingLogs, SchedulerLogs, TaskLogs,
	// WebserverLogs, and WorkerLogs.
	SchedulerLogs *ModuleLoggingConfiguration

	// A JSON blob that provides configuration to use for logging with respect to the
	// various Apache Airflow services: DagProcessingLogs, SchedulerLogs, TaskLogs,
	// WebserverLogs, and WorkerLogs.
	TaskLogs *ModuleLoggingConfiguration

	// A JSON blob that provides configuration to use for logging with respect to the
	// various Apache Airflow services: DagProcessingLogs, SchedulerLogs, TaskLogs,
	// WebserverLogs, and WorkerLogs.
	WebserverLogs *ModuleLoggingConfiguration

	// A JSON blob that provides configuration to use for logging with respect to the
	// various Apache Airflow services: DagProcessingLogs, SchedulerLogs, TaskLogs,
	// WebserverLogs, and WorkerLogs.
	WorkerLogs *ModuleLoggingConfiguration
}

// The Logging Configuration of your Amazon MWAA environment.
type LoggingConfigurationInput struct {

	// A JSON blob that provides configuration to use for logging with respect to the
	// various Apache Airflow services: DagProcessingLogs, SchedulerLogs, TaskLogs,
	// WebserverLogs, and WorkerLogs.
	DagProcessingLogs *ModuleLoggingConfigurationInput

	// A JSON blob that provides configuration to use for logging with respect to the
	// various Apache Airflow services: DagProcessingLogs, SchedulerLogs, TaskLogs,
	// WebserverLogs, and WorkerLogs.
	SchedulerLogs *ModuleLoggingConfigurationInput

	// A JSON blob that provides configuration to use for logging with respect to the
	// various Apache Airflow services: DagProcessingLogs, SchedulerLogs, TaskLogs,
	// WebserverLogs, and WorkerLogs.
	TaskLogs *ModuleLoggingConfigurationInput

	// A JSON blob that provides configuration to use for logging with respect to the
	// various Apache Airflow services: DagProcessingLogs, SchedulerLogs, TaskLogs,
	// WebserverLogs, and WorkerLogs.
	WebserverLogs *ModuleLoggingConfigurationInput

	// A JSON blob that provides configuration to use for logging with respect to the
	// various Apache Airflow services: DagProcessingLogs, SchedulerLogs, TaskLogs,
	// WebserverLogs, and WorkerLogs.
	WorkerLogs *ModuleLoggingConfigurationInput
}

// Internal only API.
type MetricDatum struct {

	// Internal only API.
	//
	// This member is required.
	MetricName *string

	// Internal only API.
	//
	// This member is required.
	Timestamp *time.Time

	// Internal only API.
	Dimensions []Dimension

	// Internal only API.
	StatisticValues *StatisticSet

	// Unit
	Unit Unit

	// Internal only API.
	Value *float64
}

// A JSON blob that provides configuration to use for logging with respect to the
// various Apache Airflow services: DagProcessingLogs, SchedulerLogs, TaskLogs,
// WebserverLogs, and WorkerLogs.
type ModuleLoggingConfiguration struct {

	// Provides the ARN for the CloudWatch group where the logs will be published.
	CloudWatchLogGroupArn *string

	// Defines that the logging module is enabled.
	Enabled *bool

	// Defines the log level, which can be CRITICAL, ERROR, WARNING, or INFO.
	LogLevel LoggingLevel
}

// A JSON blob that provides configuration to use for logging with respect to the
// various Apache Airflow services: DagProcessingLogs, SchedulerLogs, TaskLogs,
// WebserverLogs, and WorkerLogs.
type ModuleLoggingConfigurationInput struct {

	// Defines that the logging module is enabled.
	//
	// This member is required.
	Enabled *bool

	// Defines the log level, which can be CRITICAL, ERROR, WARNING, or INFO.
	//
	// This member is required.
	LogLevel LoggingLevel
}

// Provide the security group and subnet IDs for the workers and scheduler.
type NetworkConfiguration struct {

	// A JSON list of 1 or more security groups IDs by name, in the same VPC as the
	// subnets.
	SecurityGroupIds []string

	// Provide a JSON list of 2 subnet IDs by name. These must be private subnets, in
	// the same VPC, in two different availability zones.
	SubnetIds []string
}

// Internal only API.
type StatisticSet struct {

	// Internal only API.
	Maximum *float64

	// Internal only API.
	Minimum *float64

	// Internal only API.
	SampleCount *int32

	// Internal only API.
	Sum *float64
}

// Error information of update, if applicable.
type UpdateError struct {

	// Error code of update.
	ErrorCode *string

	// Error message of update.
	ErrorMessage *string
}

// Provide the security group and subnet IDs for the workers and scheduler.
type UpdateNetworkConfigurationInput struct {

	// Provide a JSON list of 1 or more security groups IDs by name, in the same VPC as
	// the subnets.
	//
	// This member is required.
	SecurityGroupIds []string
}
